# Шахматы с открытым миром 1.2

**Шахматы с открытым миром 1.2** – это инновационная версия классических шахмат, где традиционные фигуры перемещаются по динамичному игровому полю, окутанному туманом войны, а на клетках появляются разнообразные бонусы и монеты. Игра объединяет глубокую стратегию классических шахмат с элементами исследования, случайности и управления ресурсами.

## Оглавление

- [Обзор игры](#обзор-игры)
- [Концепция игры](#концепция-игры)
- [Основные механики](#основные-механики)
  - [Структура хода и перемещения](#структура-хода-и-перемещения)
  - [Туман войны и механизм раскрытия клеток](#туман-войны-и-механизм-раскрытия-клеток)
  - [Генерация бонусов и монет](#генерация-бонусов-и-монет)
  - [Механика боя](#механика-боя)
  - [Магазин](#магазин)
- [Стратегические особенности](#стратегические-особенности)
- [Дополнительные замечания](#дополнительные-замечания)

---

## Обзор игры

**Шахматы с открытым миром 1.2** представляет собой гибрид классических шахмат и открытого мира, где игровой процесс динамичен и наполнен неожиданностями. Ваша задача – не только выиграть шахматную партию, но и эффективно использовать бонусы, собирать монеты и умело управлять ресурсами, чтобы одержать победу.

## Концепция игры

В этой игре шахматное поле превращается в открытый мир, где:
- **Туман войны** скрывает большую часть поля, и его нужно «рассекречивать» движением фигур.
- **Клетки** постоянно меняются: при их раскрытии появляются бонусы и монеты, а спустя время (если клетка не посещается) всё вновь покрывается туманом, и объекты исчезают.
- **Несколько ходов за раз:** игроку предоставляется возможность совершить до 3 перемещений за ход, что добавляет динамичности и требует продуманной тактики.

## Основные механики

### Структура хода и перемещения

- **Несколько перемещений за ход:**  
  Каждый игрок в свой ход может совершить до 3 перемещений. Выбирайте фигуру, перемещайтесь по полю и используйте бонусы, чтобы усилить свою позицию.
  
- **Виды перемещений:**  
  - Фигуры с коротким радиусом (например, пешка и король) перемещаются на одну клетку.
  - Фигуры дальнего боя (ладья, слон, ферзь) могут двигаться на несколько клеток за один ход. При их перемещении проверяется каждое промежуточное звено пути.

- **Потраченное перемещение:**  
  Даже если ваша фигура погибает во время перемещения (например, попадая на клетку с бонусом «damage»), это перемещение засчитывается. Если у вас осталось еще перемещений, вы сможете совершить следующие ходы.

### Туман войны и механизм раскрытия клеток

- **Начальное состояние:**  
  Изначально почти все поле скрыто туманом.
  
- **Раскрытие клеток:**  
  Фигуры при перемещении «освещают» окружающие клетки (обычно 5×5 клеток вокруг них), делая их видимыми. На этих клетках становятся доступны бонусы и монеты.
  
- **Старение клетки:**  
  Если клетка остаётся неизменной (то есть долго не посещается ни одной фигурой), её «счётчик старения» растёт. При достижении определённого порога (например, 5 ходов) клетка вновь покрывается туманом, и все бонусы или монеты, находящиеся на ней, исчезают. Это позволяет в дальнейшем генерировать новые бонусы на этих клетках.

### Генерация бонусов и монет

- **Шанс генерации:**  
  Каждая новая (раскрытая) клетка имеет заданный шанс (по умолчанию 10%) сгенерировать объект.
  
- **Соотношение бонус/монета:**  
  Если для клетки срабатывает шанс генерации, то:
  - С вероятностью 95% в клетке появляется бонус.
  - С вероятностью 5% появляется монета.
  
- **Типы бонусов:**  
  Возможные бонусы включают:
  - **Regen (восстановление):** Восстанавливает часть HP фигуры (кроме короля).
  - **HP Upgrade (повышение здоровья):** Увеличивает максимальное значение HP фигуры (кроме короля).
  - **Damage (урон):** Наносит случайный урон (от 1 до 5 единиц) фигуре, попавшей на клетку.  
    При этом вероятность появления бонуса «damage» динамически увеличивается после 100 ходов (до 50%).
  - **King HP Upgrade:** Увеличивает максимальное здоровье короля или восстанавливает его.
  - **Add Piece:** Если рядом есть свободное место, создает дополнительную фигуру такого же типа.
  
- **Монеты:**  
  Монеты генерируются аналогичным образом, но теперь, как бонусы, монеты исчезают, если клетка «стареет» (т.е. покрывается туманом). Собранные монеты можно потратить в магазине.

### Механика боя

- **Бой между фигурами:**  
  Когда ваша фигура перемещается на клетку, занятую вражеской фигурой, происходит бой. Результат боя определяется сравнением HP фигур:
  - Если HP атакующей фигуры меньше HP защитника, атакующая фигура погибает, а защитник остаётся с уменьшенным количеством HP.
  - Если HP атакующей фигуры больше, защитник погибает, а атакующая фигура остаётся с уменьшенным количеством HP.
  - При равных значениях HP защитник погибает, а атакующая фигура остаётся с 1 единицей HP.

- **Опасности на пути:**  
  Для фигур дальнего боя (ладья, слон, ферзь) каждый промежуточный шаг пути проверяется на наличие бонуса «damage». Если фигура проходит через клетку с таким бонусом, она получает случайный урон.  
  Если фигура погибает в процессе перемещения, этот ход засчитывается (то есть расходуется одно перемещение), но оставшиеся перемещения остаются в распоряжении игрока.

### Магазин

- **Взаимодействие:**  
  При попадании на клетку с торговцем открывается магазин.
  
- **Что можно купить:**  
  В магазине можно приобрести улучшения за собранные монеты, например:
  - **Расширение хода:** Увеличивает дальность перемещения некоторых фигур.
  - **Увеличение HP:** Повышает здоровье фигур.
  - **Уменьшение HP врага:** Наносит урон вражеским фигурам.
  - **Проклятие:** Применяет негативный эффект на противника.
  
- **Стоимость:**  
  Все предметы в магазине имеют фиксированную стоимость (по умолчанию 6 монет).

---

## Стратегические особенности

- **Контроль над туманом:**  
  Активное перемещение фигур позволяет раскрывать больше клеток, что помогает обнаружить бонусы, монеты и вражеские фигуры. Однако не забывайте, что клетки, оставшиеся неизменными, снова покрываются туманом, и объекты на них исчезают.

- **Риск и награда:**  
  Попадание на клетку с бонусом может дать вам значительное преимущество (например, восстановить здоровье или улучшить характеристики фигуры), но некоторые бонусы (damage) несут риск нанесения урона. Особенно будьте осторожны при длинных перемещениях: если ваша фигура (например, ладья или ферзь) проходит по нескольким клеткам, где могут находиться опасные бонусы, существует риск накопительного урона.

- **Управление ресурсами:**  
  Монеты, собранные на поле, являются важным ресурсом для покупок в магазине. Старайтесь балансировать между агрессивной атакой, сбором монет и сохранением здоровья фигур.

- **Тактическое планирование:**  
  Игра предоставляет несколько перемещений за ход, что позволяет комбинировать атаки, сбор бонусов и тактическое перемещение. Обдумывайте каждый ход, учитывая не только шахматные правила, но и динамичные элементы игрового поля.

---

## Дополнительные замечания

- **Динамика вероятностей:**  
  Исходное распределение бонусов задается в файле (например, regeneration – 42%, HP upgrade – 32%, damage – 20%, и т.д.). По мере увеличения количества ходов вероятность появления бонуса «damage» постепенно растет (до 50% после определённого количества ходов), что делает игру более рискованной с течением времени.

- **Обновление клеток:**  
  Если клетка долго не посещалась, она «стареет» и вновь покрывается туманом, удаляя все бонусы и монеты, которые на ней находились. Это позволяет системе генерировать новые объекты, когда клетка снова становится видимой.

- **Механика потери хода:**  
  Даже если ваша фигура погибает в процессе перемещения (например, из-за попадания бонуса damage на пути), это перемещение засчитывается. Остальные перемещения остаются, если таковые имеются, и ход продолжается у вас до истечения лимита.

---

Наслаждайтесь игрой, экспериментируйте с тактикой и стратегией, и помните – каждая партия уникальна благодаря элементам случайности и динамическому игровому миру!

Удачи и приятной игры!
